
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "wait.h"
#include "cgdk.h"
#include "pcx.h"
#include "car.h"
#include "csf.h"
#include "file.h"


int main (void)
{
  void far *pcxBuf;
  TCAR *carHandle;
  long offset;
  TCSF *mcsf;
  TCSF *scsf;
  char singleName [80];
  char singleExt [80];
  char singleSpec [160];
  char *s;
  int count;
  int i;

  carHandle = CAR_open (CAR_EMULATION);

  printf ("\n"
          "CSFEXTR - convertor of multi Cybertek Sprite/Font\n"
          "          to single Cybertek Sprite/Font files.\n"
          "\n%s\n",CGDK_copyright);

  CGDK_init ();

  if (_argc != 2+1)
  {
    CGDK_exit ("Syntax is : CSFEXTR <single_name> <multi.csf>\n", EXIT_FAILURE);
  }

  mcsf = CSF_new (carHandle, _argv [2]);
  if (mcsf == NULL)
  {
    sprintf (exitStr, "\"%s\" is an invalid Sprite/Font file.\n", _argv [2]);
    CGDK_exit (exitStr, 3);
  }

  printf ("\n"
          "Extracting %li single sprites from %s\n"
          "\n"
          "Please wait ...\n", mcsf->count, _argv [2]);

  strcpy (singleName, _argv [1]);
  if (strlen (singleName) > 4)
  {
    singleName [4] = 0;
  }

  for (i = 0; i < mcsf->count; i++)
  {
    scsf = CSF_create (CSF_raw (mcsf, i), mcsf->sizeX, mcsf->sizeY, mcsf->colors-1, 1, NULL);
    if (scsf == NULL)
    {
      CGDK_exit ("\nNot enough memory.\n", EXIT_FAILURE);
    }

    sprintf (singleSpec, "%s%04i.csf", singleName, i);

    if (CSF_save (scsf, singleSpec) != 0)
    {
      sprintf (exitStr, "\nUnable to extract %s.\n\n",singleName);
      CGDK_exit (exitStr, 4);
    }
    WAIT_flashPrint (i, mcsf->count);
  }

  sprintf (exitStr, "All sprites succesfully extracted.\n", _argv [2]);
  CGDK_exit (exitStr, EXIT_FAILURE);

  return 0;
}
