
#include <stdlib.h>
#include <mem.h>

#include "svga.h"
#include "car.h"
#include "lin.h"
#include "csf.h"

/*
TCSF *CSF_new (int CAR_handle, const char *FontName)
{
  TCSF *fnt;

  fnt = (TCSF *) SPRITE_new (CAR_handle, FontName);

  return fnt;
}

void CSF_delete (TCSF *fnt)
{
  SPRITE_delete (fnt);
}

void CSF_setPal (TCSF *fnt, TRGBColor *colors, int firstColor, int numColors)
{
  SPRITE_setPal ((TSPRITE *) fnt, colors, firstColor, numColors);
}


void CSF_updateColors (TCSF *fnt, TRGBColor *pal, int baseColor, int palLen)
{
  SPRITE_updateColors ((TSPRITE *) fnt, pal, baseColor, palLen);
}

TMIRROR *CSF_newMirror (TCSF *fnt, int charsTotal, int linesTotal)
{
  if ((fnt != NULL) && (fnt->charTable))
  {
    if (fnt->charTable)
    {
      return MIRROR_new (fnt->raw, fnt->sizeX *
                         CSF_getTextLength (fnt, charsTotal),
                         CSF_getTextWidth (fnt, linesTotal) * fnt->sizeY);
    }
    return NULL;
  }
  return NULL;
}


int CSF_changeBaseColor (TCSF *fnt, long newBaseColor)
{
  return SPRITE_changeBaseColor ((TSPRITE *) fnt, newBaseColor);
}
*/



int CSF_getTextWidth (TCSF *fnt, int linesTotal) //vyska
{
  if (fnt->charTable)
    return (fnt->sizeY + fnt->ySpacing)*linesTotal;
  return 0;
}

int CSF_getTextLength (TCSF *fnt, int charsTotal)
{
  if (fnt->charTable)
    return (fnt->sizeX + fnt->xSpacing)*charsTotal;
  return 0;
}

int CSF_getTextSize (TCSF *fnt, int charsTotal, int linesTotal)
{
  return CSF_getTextLength (fnt, charsTotal) *
           CSF_getTextWidth (fnt, linesTotal) ;
}

void CSF_setXSpacing (TCSF *fnt, int xSpacing)
{
  if (fnt->charTable)
    fnt->xSpacing = xSpacing;
}

void CSF_setYSpacing (TCSF *fnt, int ySpacing)
{
  if (fnt->charTable)
    fnt->ySpacing = ySpacing;
}

void *CSF_char (TCSF *csf, int c)
{
  unsigned char charOffset;

  if (csf)
  {
    if (csf->charTable)
    {
      charOffset = csf->charTable [(unsigned char)c];
//      if (charOffset == 0)
//      return NULL;
//      else
      return csf->raw + csf->size*charOffset;
    }
  }
  return NULL;
}

void *CSF_raw (TCSF *csf, int c)
{
  unsigned char charOffset;

  if (csf)
  {
    c = c % csf->count;
    return ((char *)csf->raw+c*csf->size);
  }
  return NULL;
}

void CSF_cpyText (TCSF *fnt, const char *Text, void *Dst,
                 int X, int Y, int sizeX, int sizeY)
{
  int i = 0;
  char c;
  void *charPtr;

  if ((fnt != NULL) && (fnt->charTable))
  {
    while ((c = Text [i]) != 0)
    {
      switch (c)
      {
        case '\n':
        {
          Y += fnt->sizeY + fnt->ySpacing;
          X = 0;
          break;
        }
        case '\r':
        {
          X = 0;
          break;
        }
        default:
        {
          charPtr = CSF_char (fnt, c);
//          if (charPtr != NULL)
          {
            LIN_movSpr (Dst, X, Y, sizeX, sizeY,
                        charPtr, fnt->sizeX, fnt->sizeX, fnt->sizeY);
          }
          X += fnt->sizeX + fnt->xSpacing;
          break;
        }
      }
      i++;
    }
  }
}

void CSF_putChar (TCSF *fnt, char Char, int X, int Y, int type)
{
  void *charPtr;

  if ((fnt != NULL) && (fnt->charTable))
  {
//    if (Char == 0)
//    {
//      Char = ' ';
//    }

    charPtr = CSF_char (fnt,Char);

//    if (charPtr == NULL)
//    {
//      charPtr = CSF_char (fnt, ' ');
//      if (charPtr == NULL)
//      {
//      charPtr = CSF_char (fnt, '.');
//      }
//    }
//    if (charPtr)
    {
      #ifndef __TURBOC__
        if (type)
        {
          SVGAC_putWin (charPtr, X, Y, fnt->sizeX, fnt->sizeY, fnt->sizeX);
        }
        else
        {
          SVGAC_putSpr (charPtr, X, Y, fnt->sizeX, fnt->sizeY, fnt->sizeX);
        }
      #else
        if (type)
        {
	  SVGA_putWin (charPtr, X, Y, fnt->sizeX, fnt->sizeY, fnt->sizeX);
	}
	else
	{
	  SVGA_putSpr (charPtr, X, Y, fnt->sizeX, fnt->sizeY, fnt->sizeX);
        }
      #endif
    }
  }
}


void CSF_print (TCSF *fnt, const char *Text, int X, int Y)
{
  int i = 0;
  char c;
  void *charPtr;
  int oldX = X;

  #ifdef __TURBOC__
    SVGA_flush ();
  #endif

  if ((fnt != NULL) && (fnt->charTable))
  {
    while ((c = Text [i]) != 0)
    {
      switch (c)
      {
        case '\n':
        {
          Y += fnt->sizeY + fnt->ySpacing;
          X = oldX;
          break;
        }
        default:
        {
          CSF_putChar (fnt, c, X, Y, 0);
          X += fnt->sizeX + fnt->xSpacing;
          break;
        }
      }
      i++;
    }
  }
}




void CSF_getTextBufSize (char *textBuf, int *sizeX, int *sizeY, TCSF *fnt)
{
  int i;
  int len = 0;
  short formatX, formatY;

  *sizeX = 0;
  *sizeY = 0;

  for (i = 0; textBuf [i] != 0; i++)
  {
    switch (textBuf [i])
    {
      case '\n':
      {
        if (*sizeX < len)
          *sizeX = len;
        (*sizeY)++;
        len = 0;
        break;
      }
      case '\r':
      {
        break;
      }
      default:
      {
        len++;
      }
    }
  }

  if (fnt != NULL)
  {
    formatX = SVGA_maxX / fnt->sizeX;
    formatY = SVGA_maxY / fnt->sizeY;
    if (formatX > *sizeX)
      *sizeX = formatX;
    if (formatY > *sizeY)
      *sizeY = formatY;
  }
}

short *CSF_createTextMapBuffer (char *textBuf, int textSizeX, int textSizeY)
{
  int i,j;
  int textBufOffset = 0;
  unsigned char c;
  short *mapBuf;

  mapBuf = (short *) _calloc (textSizeX*textSizeY,sizeof (short), NULL);
  if (mapBuf == NULL)
  {
//    printf ("Out of memory !\n");
    return NULL;
  }

  for (i = 0; i < textSizeY; i++)
  {
    j = 0;
    if (textBuf [textBufOffset+j] == 0)
    {
      break;
    }
    while ((c = textBuf [textBufOffset+j]) != '\n')
    {
      mapBuf [i*textSizeX+j] = c;
      j++;
    }
    j++;
    textBufOffset += j;
  }
  return mapBuf;
}

char *CSF_createTextSprBuffer (TCSF *fnt)
{
  int i;
  char text [2];
  char *sprBuf;

  sprBuf = (char *) _calloc (fnt->sizeX*fnt->sizeY,256, NULL);
  if (sprBuf == NULL)
  {
//    printf ("Out of memory !\n");
    return NULL;
  }

  text [1] = 0;
  for (i = 0; i < 256; i++)
  {
    text [0] = i;
    CSF_cpyText (fnt, text, sprBuf+i*fnt->sizeX*fnt->sizeY,
              0, 0, fnt->sizeX,fnt->sizeY);
  }
  return sprBuf;
}

char *CSF_createTextBuf (TCAR *carHandle, const char *fileName)
{
  char *textBuf;
  int textBufLen;
  int i;

  if ((textBufLen = CAR_seek (carHandle, fileName, 0)) == -1)
  {
//    printf ("Text file %s not found\n", fileName);
    return NULL;
  }
  if (textBufLen == 0)
  {
//    printf ("Nothing to view !\n");
    return NULL;
  }

  textBuf = (char *) _alloc (textBufLen+2);
  if (textBuf == NULL)
  {
//    printf ("Out of memory !\n");
    return NULL;
  }
  if ( CAR_read (carHandle, textBuf, textBufLen) != textBufLen)
  {
//    printf ("Error reading text file %s\n", fileName);
    return NULL;
  }
  for (i = 0; i < textBufLen; i++)
  {
    if (textBuf [i] == 0)
      textBuf [i] = 255;
  }
  textBuf [textBufLen] = '\n';
  textBuf [textBufLen+1] = 0;

  return textBuf;
}
