
  /*                                                                      */
  /*  FLIC.H - Autodesk FLIC (FLI, FLIC) player library version 0.1       */
  /*                                                                      */
  /*  Copyright (C) 1995 Action Excel Inc.                                */
  /*                                                                      */
  /*  CREATED: 26-10-95 Cerberus                                          */
  /*                                                                      */
  /*  Please check FLICTEST.CPP for example how to use this library.      */
  /*                                                                      */
  /* Supported memory models : LARGE, DOS4GW                              */



#ifndef _FLIC_H
  #define _FLIC_H

  #ifdef __cplusplus
  extern "C" {
  #endif

  #include "pal.h"
  #include "car.h"

  extern int FLIC_framesCount;
  extern int FLIC_length;
  extern int FLIC_width;
  extern int FLIC_delay;
//  extern void far *FLIC_videoBuf;
//  extern RGBColor *FLIC_PALBuf;

  extern int FLIC_getInfo (TCAR *carHandle, const char *fileName, int *sizeX, int *sizeY);

  extern int FLIC_load (TCAR *carHandle, const char *FileName,
                        void far *videoBuf, int videoBufSizeX, int videoBufSizeY,
                        TRGBColor *PALBuf);

  /* initializes FLIC library. Sets default PAK file handle filename,
     video buffer, and pallette buffer

     PAK_Handle = handle of an opened PAK file
     VideoBuf   = address of memory/video buffer
     PalBuf     = address of memory/palette buffer

     On success returns 0;
     On error returns -1 - invalid FLIC file or
                           not enough memory for 64000 buffer.
  */

  extern void FLIC_play (void);
  /* calculates next animation frame
     Use after FLIC_Init */

  extern void FLIC_unload (void);
  /* deinitializes FLIC library and frees allocated memory. */

  extern int FLIC_videoBufSeg;
  extern int FLIC_videoBufOff;
  extern int FLIC_videoBufSizeX;
  extern int FLIC_videoBufSizeY;

  #include "flicp_.h"

  #ifdef __cplusplus
  }
  #endif


#endif
