
#include <stdio.h>
#include <stdlib.h>

#include "wait.h"
#include "cgdk.h"
#include "pcx.h"
#include "car.h"
#include "csf.h"
#include "file.h"

int main (void)
{
  void far *pcxBuf;
  TRGBColor palette [256];
  int sizeX, sizeY;
  int bytesPerPixel;
  TCAR *carHandle;
  long offset;
  TCSF *csf;

  carHandle = CAR_open (CAR_EMULATION);

  printf ("\n"
          "PCX2CSF - convertor of PCX pictures to Cybertek Sprite/Font\n"
          "\n%s\n",CGDK_copyright);

  CGDK_init ();

  if (_argc != 3)
  {
    CGDK_exit ("Syntax is : PCX2CSF <filename.pcx> <filename.csf>\n", EXIT_FAILURE);
  }

  if (PCX_getInfo (carHandle, _argv [1], &sizeX, &sizeY, &bytesPerPixel))
  {
    sprintf (exitStr, "\"%s\" is an invalid PCX file.\n", _argv [1]);
    CGDK_exit (exitStr, 3);
  }

  printf ("\"%s\" - %i x %i x %i colors picture.\n", _argv [1], sizeX, sizeY, 2 << ((8*bytesPerPixel)-1));

  pcxBuf = (void far *) _calloc ((unsigned)(sizeX*sizeY*bytesPerPixel),1,NULL);

  if (PCX_load (carHandle, _argv [1], pcxBuf, sizeX, sizeY, palette) != 0)
  {
    sprintf (exitStr, "\nError loading \"%s\".\n", _argv [1]);
    CGDK_exit (exitStr, EXIT_FAILURE);
  }
//  F_save ("pcxdump.raw",pcxBuf,sizeX*sizeY);

  printf ("\nConverting, please wait ...\n");

  csf = CSF_create ((void *)pcxBuf, sizeX, sizeY, palette, 1, NULL);
  if (csf == NULL)
  {
    CGDK_exit ("Not enough memory.\n", EXIT_FAILURE);
  }
  if (CSF_save (csf, _argv [2]) != 0)
  {
    sprintf (exitStr, "\nError creating %s.\n\n",_argv [2]);
    CGDK_exit (exitStr, 4);
  }

  sprintf (exitStr, "%s was succesfully created.\n",_argv [2]);
  CGDK_exit (exitStr, EXIT_FAILURE);

  return 0;
}
