
#ifndef _VESA_H_
#define _VESA_H_

  #ifdef __cplusplus
  extern "C" {
  #endif

  #include "b256_.h"

  #define PAL_6BIT 6
  #define PAL_8BIT 8

  #define LINEAR_FRAME_BUFFER 0x4000

  #define VESA_MODE 0x100
  #define VESA_640x400x256 0x100
  #define VESA_640x480x256 0x101
  #define VESA_800x600x256 0x103
  #define VESA_1024x768x256 0x105
  #define VESA_1280x1024x256 0x107

  #define VESA_20 0x200
  #define VESA_12 0x102
  #define VESA_10 0x100
  #define VESA_NONE 0x0000

//  #define VESA_SETMODE_OK 0x20
//  #define VESA_SETMODE_NOSUPPORT 0x13
  #define VESA_SETMODE_SWITCHERROR 0x11
  #define VESA_SETMODE_NOVIRTUAL 0x12

  #define VESA_S3MODE_AUTODETECT 0
  #define VESA_S3MODE_COMPATIBLEBIOS 1
  #define VESA_S3MODE_UNCOMPATIBLEBIOS 2
  #define VESA_MATROXMODE_AUTODETECT 0
  #define VESA_MATROXMODE_ON 1
  #define VESA_MATROXMODE_OFF 2
//  extern int VESA_bytesPerLine;
//  extern int VESA_bitsPerPixel;
  extern char *VESA_OEMString;
  extern int *VESA_modes;

  extern int VESA_version;
  extern long VESA_memory;
  extern int VESA_S3;
  extern int VESA_S3Mode;
  extern int VESA_matrox;
  extern int VESA_matroxMode;
  #define VESA_S3USE ((VESA_S3Mode == VESA_S3MODE_UNCOMPATIBLEBIOS) || ((VESA_S3Mode == VESA_S3MODE_AUTODETECT) && VESA_S3))
  #define VESA_MATROXUSE ((VESA_matroxMode == VESA_MATROXMODE_ON) || ((VESA_matroxMode == VESA_MATROXMODE_AUTODETECT) && VESA_matrox))

//  extern void far *VESA_linearBuf;
//  extern char  VESA_palType;
  extern void VESA_scroll (void);

  extern int VESA_init (void);
  extern void VESA_done (void);
  extern int VESA_getModeInfo (int Mode, int *XRes, int *YRes,
                          int *BytesPerLine,int *BitsPerPixel);
  extern int VESA_setVideoMode (int VideoMode);

  /*
  extern void (*VESA_setPal) (TRGBColor *PAL, int StartColor, int NumColors);
  extern void (*VESA_getPal) (TRGBColor *PAL, int StartColor, int NumColors);
  extern void (*VESA_clearPal) (int StartColor, int NumColors);
  */

  /*
  extern void (*VESA_clearScreen) (long Color);
  extern void (*VESA_getWin) (void *Win,int X,int Y,
                                 int Size_X, int Size_Y);
  extern void (*VESA_putSpr) (void *Sprite,int X,int Y,
                                 int Size_X, int Size_Y);
  extern void (*VESA_putWin) (void *Win,int X,int Y,
                                 int Size_X, int Size_Y);
  extern void (*VESA_putPixel) (int X, int Y, long Pixel);
  extern long (*VESA_getPixel) (int X, int Y);
  */

  extern void VESA_setBank (int bank);

  extern int VESA_init (void);
  extern int VESA_videoModeSupported (int VideoMode);
//  extern void VESA_setDisplayStart (int x,int y,int waitVRT);
  extern int VESA_returnVideoMode (void);
  extern int VESA_switchVideoMode (int videoMode);
  extern void *VESA_saveState (void);
  extern void VESA_restoreState (void *stateBuf);

//  extern int VESA_setPixelsPerLine (int pixelsPerLine,int *newBytes=NULL, int *newPixels=NULL, int *newScanlines=NULL);
//  extern int VESA_setBytesPerLine (int bytesPerLine,int *newBytes=NULL, int *newPixels=NULL, int *newScanlines=NULL);

  #ifdef __cplusplus
  }
  #endif

#endif
